<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_HotelContractType ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_HotelContractType extends AbstractStructArrayBase
{
    /**
     * The ContractType
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_HotelContractType[]
     */
    public $ContractType;
    /**
     * Constructor method for ArrayOfJP_HotelContractType
     * @uses ArrayOfJP_HotelContractType::setContractType()
     * @param \StructType\JP_HotelContractType[] $contractType
     */
    public function __construct(array $contractType = array())
    {
        $this
            ->setContractType($contractType);
    }
    /**
     * Get ContractType value
     * @return \StructType\JP_HotelContractType[]|null
     */
    public function getContractType()
    {
        return $this->ContractType;
    }
    /**
     * Set ContractType value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_HotelContractType[] $contractType
     * @return \ArrayType\ArrayOfJP_HotelContractType
     */
    public function setContractType(array $contractType = array())
    {
        foreach ($contractType as $arrayOfJP_HotelContractTypeContractTypeItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_HotelContractTypeContractTypeItem instanceof \StructType\JP_HotelContractType) {
                throw new \InvalidArgumentException(sprintf('The ContractType property can only contain items of \StructType\JP_HotelContractType, "%s" given', is_object($arrayOfJP_HotelContractTypeContractTypeItem) ? get_class($arrayOfJP_HotelContractTypeContractTypeItem) : gettype($arrayOfJP_HotelContractTypeContractTypeItem)), __LINE__);
            }
        }
        $this->ContractType = $contractType;
        return $this;
    }
    /**
     * Add item to ContractType value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_HotelContractType $item
     * @return \ArrayType\ArrayOfJP_HotelContractType
     */
    public function addToContractType(\StructType\JP_HotelContractType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_HotelContractType) {
            throw new \InvalidArgumentException(sprintf('The ContractType property can only contain items of \StructType\JP_HotelContractType, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ContractType[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_HotelContractType|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_HotelContractType|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_HotelContractType|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_HotelContractType|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_HotelContractType|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ContractType
     */
    public function getAttributeName()
    {
        return 'ContractType';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJP_HotelContractType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
